PROGRAM ArbolB (input,ouput);
USES crt;
CONST
     n=2;             (* orden del rbol *)
     DosN=2*n;        (* mximo nmero de claves por pgina *)
TYPE
    tClave        =Integer;
    tArbolB       =^Pagina;
    RangoNClaves  =1..DosN;
    TablaClaves   =Array [RangoNclaves] OF tClave;
    TablaDescend  =Array [0..DosN] OF tArbolB;
    Pagina        =Record
                       NumClaves :RangoNClaves;
                       Claves    :TablaClaves;
                       Descend   :TablaDescend
                   end;
    RangoPosic=0..DosN;

VAR
   a:tArbolB;
   b:tClave;
FUNCTION Posicion (claves:TablaClaves;NumClaves:RangoNClaves;
                   x:tClave;VAR Encontrado:Boolean):RangoPosic;

 (* Busca la clave "x" en la tabla "Claves". "NumClaves" indica el nmero de
    claves que contiene la tabla.
    "Encontrado" toma el valor True si se encuentra la clave, en cuyo caso la
     funcin devuelve la posicin que ocupa "x" en "Claves". Si la clave no est
     en la tabla, "encontrado" toma el valor false, y la funcin devuelve un
     nmero que especifica la posicin de la clave anterior y posterior a x, de la siguiente
     manera:

            - Si posicin=0, la clave buscada es menor que todas.
            - Si posicin=DosN, la clave buscada es mayor que todas.
            - Si Posicin=i (0<i<DosN), entonces ci<x<ci+1.
    La funcin utiliza el algoritmo de Bsqueda Binaria para localizar
    clave *)

var
   iz,de,me:integer;
begin
     iz:=1;
     de:=numclaves;
     repeat
           me:=(iz+de) div 2;
           if x > claves[me]
              then iz:=me+1
              else if x < claves[me]
                   then de:=me-1
                   else iz:=de+1
      until iz > de;
      encontrado:=(claves[me]=x);
      if encontrado
         then posicion:=me
         else posicion:=de
end;


procedure insertar (var a:tArbolB;x:tClave);

(* inserta la clave x en el arbol B "a" *)

var
   subeclave :boolean;
   clavequesube:tClave;
   puntquesube,
   aux:tArbolB;
   (**********************************************************************)
   (**********************************************************************)
   procedure dividirpag (a:tArbolB;var clavequesube:tClave;
                        var puntquesube:tArbolB;Pos:rangoposic);

       (* Divide la pgina que cuelga de a, insertando de manera apropiada
          clavequesube y puntquesube, y actualizando su contenido *)
   var
      nuevapag:tArbolB;
      i:integer;
      claveainsertar:tClave;
      puntinsertar:tArbolB;
   begin
        new (nuevapag);
        if pos<=n
         then
             begin  (* las n ltimas claves de a^ deben ir a la nueva pgina *)
                for i:=1 to n do
                  begin
                    nuevapag^.claves[i]:=a^.claves[i+n];
                    nuevapag^.descend[i]:=a^.descend[i+n]
                  end;
                if pos=n
                   then (* la clave que sube es precisamente la mediana, as que
                         debe volver a subir *)
                       nuevapag^.descend[0]:=puntquesube
                   else
                       begin  (* Pos < n *)
                           NuevaPag^.descend[0]:=a^.descend[n];
                           claveainsertar:=clavequesube;
                           puntinsertar:=puntquesube;
                           clavequesube:=a^.claves[n];
                           for i:=n downto pos+2 do
                               begin
                                    a^.claves[i]:=a^.claves[i-1];
                                    a^.descend[i]:=a^.descend[i-1]
                               end;
                           a^.claves[pos+1]:=claveainsertar;
                           a^.descend[pos+1]:=puntinsertar
                       end

             end
         else
           begin (* la clave que sube se inserta en la nueva pgina *)
              nuevapag^.descend[0]:=a^.descend[n+1];
              for i:=n+2 to pos do
                  begin
                       nuevapag^.claves[i-n-1]:=a^.claves[i];
                       nuevapag^.descend[i-n-1]:=a^.descend[i]
                  end;
              nuevapag^.claves[pos-n]:=clavequesube;
              nuevapag^.descend[pos-n]:=puntquesube;
              for i:=pos+1 to DosN do
                  begin
                       nuevapag^.claves[i-n]:=a^.claves[i];
                       nuevapag^.descend[i-n]:=a^.descend[i]
                  end;
              clavequesube:=a^.claves[n+1] (*Nueva clavequesube tras dividir *)
           end;
         a^.numclaves:=n;
         nuevapag^.numclaves:=n;
         puntquesube:=nuevapag
   end; (*dividirpag*)
   procedure insenpagactual (a:tArbolB; var clavequesube:tClave;
                            var puntquesube:tArbolB;pos:rangoposic;var dividida:boolean);

   (* inserta la clave clavequesube y el puntero puntquesube en la posicion pos+1
    de los dos arrays (el de claves y el de descendientes) correspondientes a la
    pagina actual (tngase en cuenta que una clave siembre sube con su puntero derecho).
    Si a^.numclaves=DosN, habr que dividir la pagina, en cuyo caso realiza las
    siguientes acciones:
               -Actualiza clavequesube con la mediana de las 2n+1 claves.
               -Deja en la pgina a^ las n claves menores que la mediana.
               -Crea una nueva pgina con las n claves mayores que la mediana
                y sus correspondientes punteros.
               -Devuelve en puntquesube un puntero a la pgina recin creada.
               -Devuelve el valor true en dividida.
    *)
   var
      i:integer;
   begin  (*insenpagactual*)
        if a^.numclaves < DosN
           then
             begin
                  for i:=a^.numclaves downto pos+1 do
                      begin
                           a^.claves[i+1]:=a^.claves[i];
                           a^.descend[i+1]:=a^.descend[i]
                      end;
                  a^.claves[pos+1]:=clavequesube;
                  a^.descend[pos+1]:=puntquesube;
                  a^.numclaves:=a^.numclaves+1;
                  dividida:=false
             end
           else
               begin
                    dividirpag (a,clavequesube,puntquesube,pos);
                    dividida:=true
               end

   end; (*insenpagactual*)

   procedure buscarins (a:tArbolB; x:tClave; var subeclave:boolean;
                        var clavequesube:tClave; var puntquesube:tArbolB);

   (* inserta la clave x en el (sub)rbol a. Si la pgina raz del (sub)rbol
      "a" se ha dividido, entonces devuelve:
      - true en subeclave,
      -la clave que habr que insertar en el nivel anterior en clavesube.
      -el subrbol con las claves menores en "a".
      -el subrbol con las claves mayores en puntquesube.
    *)
    var
       pos:rangoposic;
       encontrado,
       pagdividida:boolean;
    begin  (*buscarins*)
         if a=nil
            then
                begin (* la clave x no est en el rbol *)
                     subeclave:=true;
                     clavequesube:=x;
                     puntquesube:=nil
                end
            else
                begin
                       pos:=posicion (a^.claves,a^.numclaves,x,encontrado);
                     if encontrado
                        then begin
                              writeln ('La clave est en el rbol');
                              subeclave:=false
                             end
                        else begin
                              buscarins (a^.descend[pos],x,subeclave,clavequesube,puntquesube);
                              if subeclave
                                 then begin (* sube una clave del nivel inferior que
                                             hay que insertar en la pg actual *)
                                             insenpagactual (a,clavequesube,puntquesube,pos,pagdividida);
                                             subeclave:=pagdividida;
                                             (* Si pagdividida=true, el proc. insenpagactual habra dejado en a, clavequesube
                                              y puntquesube los valores adecuados *)
                                      end
                             end
                end
   end; (*buscarins*)

   begin (* insertar *)
         buscarins (a,x,subeclave,clavequesube,puntquesube);
         if subeclave
            then
                begin
                     aux:=a;
                     new (a);
                     with a^ do
                          begin
                               numclaves:=1;
                               claves[1]:=clavequesube;
                               descend[0]:=aux;
                               descend[1]:=puntquesube
                          end
                end
    end; (*insertar *)
    procedure imprimirarbol (a:tArbolB;nivel:integer);
       var
          i:integer;
       begin
            if a<>nil
               then
                   with a^ do
                        begin
                             for i:=1 to nivel do
                                 write (' ');
                                 for i:=1 to numclaves do
                                     write (claves[i]:4);
                                 writeln;
                                 imprimirarbol (descend[0],nivel+1);
                                 for i:=1 to numclaves do
                                     imprimirarbol (descend[i],nivel+1)

                        end

       end;
begin
     clrscr;

     a:=nil;
     write ('Introduce clave: ');
     readln (b);
     while b<>0 do
           begin
                insertar (a,b);
                write ('Introduce clave: ');
                readln (b)
            end;
     imprimirarbol (a,1);
end.














