program grafos (input,output);
uses crt;
const
     max=500;
type
    nodos='A'..'H';
    tipo_nodo=char;
    tipo_adyacentes=array[1..25] of tipo_nodo;
    tipo_adyacencia=array[nodos,nodos] of 0..1;
    tipo_estado=array[nodos] of integer;
    tipo_fifo=record
                    fifo:array[1..max] of record
                                                origen,
                                                destino:char;
                                          end;
                    frente,final:integer;
              end;


var
   matriz:tipo_adyacencia;
   fifo:tipo_fifo;
   estados:tipo_estado;
   origen,destino,origen_parcial:tipo_nodo;
   adyacentes:tipo_adyacentes;
   num,i:integer;
   encontrado:boolean;

function esta (nodo:tipo_nodo):boolean;
var
   test:boolean;
begin
     test:=nodo in ['A'..'H'];
     if not test
        then writeln ('No se encuentra en el conjunto de nodos.');
     esta:=test
end;


function FifoVacia(fifo:tipo_fifo):boolean;

begin
    FifoVacia:=(fifo.frente > fifo.final);
end;

function Fifollena(fifo:tipo_fifo):boolean;

begin
    Fifollena:=(fifo.final=max);
end;

procedure asignar_adyacentes (origen,destino:tipo_nodo;
                             matriz:tipo_adyacencia;
                             var adyacentes:tipo_adyacentes;
                             var num:integer;
                             var encontrado:boolean);
var i:tipo_nodo;

begin
     encontrado:=false;
     num:=0;
     i:='A';
     while (i<='H') and not encontrado do
        begin
             if matriz[origen,i]=1
                then
                    begin
                         if i=destino
                            then encontrado:=true;
                         num:=num+1;
                         adyacentes[num]:=i
                    end;
              i:=succ(i);
        end
end;

Procedure meter(var fifo:tipo_fifo;
                Ori_Parcial,Des_Parcial:tipo_nodo;
                var estados:tipo_estado);

begin
     if not fifollena(fifo)
        then
            begin
                 with fifo do
                      begin
                           final:=final+1;
                           fifo[final].origen:=Ori_parcial;
                           fifo[final].destino:=Des_parcial;
                      end;
                 estados[Des_parcial]:=2
            end
end;

Procedure sacar(var fifo:tipo_fifo;
               var Ori_Parcial:tipo_nodo;
               var estados:tipo_estado);

begin
     if not fifovacia(fifo)
        then
            begin
                 with fifo do
                      begin
                           frente:=frente+1;
                           ori_parcial:=fifo[frente].destino;
                      end;
                 estados[ori_parcial]:=3
            end
end;


procedure inicializar_estados (var estados:tipo_estado);
var
   i:tipo_nodo;
begin
     for i:='A' to 'H' do
         estados[i]:=1;
end;


procedure inicializar_matriz(var matriz:tipo_adyacencia);
var
   i,j:tipo_nodo;
begin
    for i:='A' to 'H' do
       for j:='A' to 'H' do
            matriz[i,j]:=0;
end;

procedure inicializar_fifo(var fifo:tipo_fifo);
begin
    with fifo do
         begin
              frente:=0;
              final:=0
         end;
end;

procedure asignar_grafo(var matriz:tipo_adyacencia);

var

 origen,destino:tipo_nodo;
 car:char;


begin
    clrscr;
    writeln ('ASIGNAR GRAFO: ');
    repeat
          repeat
                Write('Dame origen :');
                origen:=readkey;
                writeln (origen);
          until esta (origen);

          repeat
                Write('Dame Destino :');
                destino:=readkey;
                writeln (destino);
          until esta (destino);
          matriz[origen,destino]:=1;
          writeln;
          write ('Desea repetir (S/N)?: ');
          car:=readkey;
          writeln (car)
    until (car in ['N','n']);

end;

procedure asignar_origdest(var origen,destino:tipo_nodo);

begin
          clrscr;
          writeln ('ORIGEN Y DESTINO DEL GRAFO: ');
          repeat
                Write('Dame origen :');
                origen:=readkey;
                writeln (origen);
          until esta (origen);
          repeat
                Write('Dame Destino :');
                destino:=readkey;
                writeln (destino);
          until esta (destino);
end;


procedure trayectoria(fifo:tipo_fifo);

var

   origen,destino2,origen2:tipo_nodo;
   i:integer;

begin
     clrscr;
     writeln ('TRAYECTORIA');
     with fifo do
          begin
               i:=final-1;
               origen:=fifo[1].origen;
               origen2:=fifo[final].origen;
               destino2:=fifo[final].destino;
               write(destino2);
               while origen2<>origen do
                     begin
                          if fifo[i].destino=origen2
                             then
                                 begin
                                      write('<---',origen2);
                                      origen2:=fifo[i].origen;
                                 end;
                          i:=i-1;
                     end;
               writeln('<---',origen)
         end
end;

begin   { principal }
     inicializar_matriz(matriz);
     asignar_grafo(matriz);
     inicializar_fifo (fifo);
     inicializar_estados (estados);
     asignar_origdest(origen,destino);
     meter(fifo,origen,origen,estados);
     repeat
                sacar(fifo,origen_parcial,estados);
                asignar_adyacentes(origen_parcial,destino,matriz,adyacentes,num,encontrado);
                for i:=1 to num do
                       meter(fifo,origen_parcial,adyacentes[i],estados);

     until encontrado or fifovacia(fifo);
     if encontrado then
         trayectoria(fifo)
     else
         writeln ('No hay trayectoria posible');
end.

