program Dijkstrita(input,output);
uses
  Crt;
const
     total=4;


type
    rango    = 'R'..'U';
    m_adya   = array [rango,rango] of word;
    conjunto = set of rango;

var
  Pesos,
  MinimosD,
  Caminos: m_adya;


Procedure visualizar_grafo (grafo:m_adya;mensaje:string);
Var
   i,j:char;
Begin
     writeln;
     writeln;
     writeln(mensaje:40-length(mensaje));
     for i:='R' to 'U' do
         begin
              for j:='R' to 'U' do
                  if (grafo[i,j]<>MAXINT)
                     then write (grafo [i,j]:3)
                     else write (0:3);
              writeln
         end
End;


Procedure asignar_grafo (var grafo:m_adya);
Var
   i,j:char;
   test:boolean;

   Procedure inicializar (var grafo:m_adya);
   Var
      i,j:char;
   Begin
      for i:='R' to 'U' do
         for j:='R' to 'U' do
            grafo [i,j]:=MAXINT
   End;

Begin
   test:=false;
   inicializar(grafo);
   Repeat
      clrscr;
      write ('Origen (F=FIN): ');
      i:=upcase(readkey);
      writeln (i);
      if (i in ['R'..'U'])
         then
             begin
                  write ('Destino (F=FIN): ');
                  j:=upcase(readkey);
                  writeln (j);
                  if (j in ['R'..'U'])
                  Then
                     Begin
                          write ('Peso: ');
                          readln (grafo [i,j])
                     End
             end;
      test:=not ((i in ['R'..'U']) and (j in ['R'..'U']))
   Until test;
   clrscr;
End;

procedure dijkstra (pesos        : m_adya;
                    var minimosd : m_adya);
var
  origen,o,d,mejor : rango;
  elegidos,
  candidatos : conjunto;


function mascercano (origen: rango;
                       minimosd : m_adya;
                       candidatos : conjunto):rango;
  var
    menor : word;
    nodo : rango;
  begin
    menor := maxint;
    for nodo := 'R' to 'U' do
      if nodo in candidatos then
       if minimosd[origen,nodo] < menor then
         begin
           menor := minimosd[origen,nodo];
           mascercano := nodo
         end
  end;


  procedure recalcular (origen,
                        mejor       : rango;
                        costos      : m_adya;
                        var mD : m_adya;
                        candidatos  : conjunto);
  var
    nodo : rango;
  begin
    for nodo := 'R' to 'U' do
      if nodo in candidatos then
        if mD [origen,nodo] > mD [origen,mejor] + mD [mejor, nodo]
           then
                mD [origen,nodo] := mD [origen,mejor] + mD [mejor, nodo]
  end;

begin
  minimosd := pesos;
  for origen := 'R' to 'U' do
    begin
      elegidos := [origen];
      candidatos := ['R'..'U'];
      mejor := mascercano (origen,minimosd,candidatos);
      candidatos := candidatos - [mejor];
      elegidos := elegidos + [mejor];
      while candidatos <> [] do
        begin
             recalcular (origen,mejor,pesos,minimosd,candidatos);
             mejor := mascercano (origen,minimosd,candidatos);
             candidatos := candidatos - [mejor];
             elegidos := elegidos + [mejor];
        end;
    end

end;

begin
  asignar_grafo (Pesos);
  visualizar_grafo (Pesos,'Matriz de Pesos');
  dijkstra (pesos, minimosd);
  visualizar_grafo (minimosd,'Caminos Minimos Dijkstra');
end.
